
////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////
// ! DO NOT EDIT unless you know exactly what you are doing ! //
////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////

//////////////////////////////// NECESSARY SETUP

//////// generate random minimal symbol setup - 5 characters
float[] genPerc( String names[] ) {
  //////// variables
  int sum = 0;
  int[] votes = new int[ names.length ];
  float[] percs = new float[ names.length ];
  //////// casting the single votes
  for( int n=0; n<names.length; n++ ) {
    int vote = int( random(pow(10,4)) * pow(10,random(1)) );
    sum += vote;
    votes[n] = vote;
  }
  //////// calculating percentages
  for( int n=0; n<names.length; n++ ) {
    float perc = votes[n] / float(sum);
    perc = round(perc*10000) / 100.0;
    percs[n] = perc;
    if( n==0 ) print( "[" + n + "] \"" + names[n] + "\" gathered " + percs[n] + "%" );
    else if( n==names.length-1) println( " and [" + n + "] \"" + names[n] + "\" " + percs[n] + "%.");
    else print( ", [" + n + "] \"" + names[n] + "\" " + percs[n] + "%");
  }
  //////// return data
  return percs;
}

//////////////////////////////// USEFUL FUNCTIONS

//////// calculate positioning according to outcome
int[] calcPos( float percs[] ) {
  int[] posis = new int[ percs.length ];
  FloatDict dicts = new FloatDict();
  for( int n=0; n<percs.length; n++ ) dicts.set( str(n), percs[n] );
  dicts.sortValuesReverse();
  String[] keys = dicts.keyArray();
  for( int n=0; n<percs.length; n++ ) {
    posis[n] = int(keys[n]);
    if( n==0 ) print( "Therefore, the first one has id [" + posis[n] + "]" );
    else if( n==percs.length-1) println( " and coming in last is id [" + posis[n] + "].");
    else print( ", followed by id [" + posis[n] + "]" );
  }
  return posis;
}

//////// draw simple demo output
void simpleDemo( String names[], float[] percs, int[] posis ) {
  //////// depiction
  background( 255 );
  textAlign( LEFT, BOTTOM );
  textSize( height/24 );
  noStroke();
  float wid = float(width) / names.length;
  for( int n=0; n<names.length; n++ ) {
    int act_id = posis[n];
    float xpos = wid*n;
    float ypos = height;
    float hei = height*percs[act_id]/100;
    fill( random(255), random(255), random(255) );
    rect( xpos, ypos, wid, -hei );
    text( " "+(n+1)+".\n "+names[act_id]+"\n "+percs[act_id]+"%", xpos, ypos-hei );
  }
}

//////// save image
void savePng() {
  //////// naming
  println( "    #### starting to export png image ..." );
  String png_name = "pngs/" + getClass().getSimpleName() + "_" + str(year()).substring(2) + nf(month(), 2) + nf(day(), 2) + "_" + nf(hour(), 2) + nf(minute(), 2) + nf(second(), 2);
  //////// saving
  save( png_name  + ".png" );
  println( png_name + ".png" + " saved!\n" );
}
