
//////// DesCode
//////// richard.dank@fh-joanneum.at
//////// http://richdank.com/theory/descode/
//////// "crazy" text step 3 | "crazy" text schritt 3

//////// variables
String[] options = { "F0rthc0ming", "All1ance", "way2goo", "Passag3", "P4rty P4rty", "5howFlake5" };
//String[] options = { "< L", "R >" };
float[] results;
int[] positions;
float[] ori_xs = new float[options.length];
float[] ori_ys = new float[options.length];
float[] dir_xs = new float[options.length];     // another array for motion in x | noch eine liste fuer bewegung in x
float[] dir_ys = new float[options.length];     // another array for motion in y | noch eine liste fuer bewegung in y

//////// setup
void setup() {
  size( 1280, 720 );
  results = genPerc( options );
  positions = calcPos( results );
  //simpleDemo( options, results, positions );
  //printArray( options );
  //printArray( results );
  //printArray( positions );
  for( int n=0; n<options.length; n++ ) {
    ori_xs[n] = random( width );
    ori_ys[n] = random( height );
    dir_xs[n] = random( -height/64,height/64 ); // random x-motion | zufaellige x-bewegung
    dir_ys[n] = random( -height/64,height/64 ); // random y-motion | zufaellige y-bewegung
  }
  background( 0 );                              // dark background | dunkler hintergrund
}

//////// draw
void draw() {
  //background( 0 );                            // comment | kommentieren
  fill( 0, 255*.1 );                            // transparent fill | transparente fuellfarbe
  rect( 0, 0, width, height );                  // fullscreen rectangle | vollflaechiges rechteck
  for( int n=0; n<options.length; n++ ) {
    textSize( results[n]*2 );
    pushMatrix();
    translate( ori_xs[n], ori_ys[n] );
    rotate( frameCount*results[n] * -.001 );    // add permanent rotation from results | permanente rotation aus den resultaten hinzufuegen
    for( int r=0; r<results[n]; r++ ) {
      if( r==0 ) fill( 255 );
      else fill( 255, 255*.3 );
      rotate( TWO_PI/100.0 );
      text( options[n], 0, 0 );
    }
    ori_xs[n] += dir_xs[n];                     // change x-position | x-position veraendern
    ori_ys[n] += dir_ys[n];                     // change y-position | y-position veraendern
    if( ori_xs[n]<0 || ori_xs[n]>width )        // when moving outside in x ... | falls ausserhalb in x ...
      dir_xs[n] *= -1;                          // ... change direction. | ... richtung aendern.
    if( ori_ys[n]<0 || ori_ys[n]>height )       // when moving outside in y ... | falls ausserhalb in y ...
      dir_ys[n] *= -1;                          // ... change direction. | ... richtung aendern.
    popMatrix();
  }
}

//////// interaction
void keyReleased() {
  if( key==' ' ) setup();
  if( keyCode==120 ) savePng();                 // f9
}
